"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _get() { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get.bind(); } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(arguments.length < 3 ? target : receiver); } return desc.value; }; } return _get.apply(this, arguments); }
function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _classPrivateFieldInitSpec(obj, privateMap, value) { _checkPrivateRedeclaration(obj, privateMap); privateMap.set(obj, value); }
function _checkPrivateRedeclaration(obj, privateCollection) { if (privateCollection.has(obj)) { throw new TypeError("Cannot initialize the same private elements twice on an object"); } }
function _classPrivateFieldGet(receiver, privateMap) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "get"); return _classApplyDescriptorGet(receiver, descriptor); }
function _classApplyDescriptorGet(receiver, descriptor) { if (descriptor.get) { return descriptor.get.call(receiver); } return descriptor.value; }
function _classPrivateFieldSet(receiver, privateMap, value) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "set"); _classApplyDescriptorSet(receiver, descriptor, value); return value; }
function _classExtractFieldDescriptor(receiver, privateMap, action) { if (!privateMap.has(receiver)) { throw new TypeError("attempted to " + action + " private field on non-instance"); } return privateMap.get(receiver); }
function _classApplyDescriptorSet(receiver, descriptor, value) { if (descriptor.set) { descriptor.set.call(receiver, value); } else { if (!descriptor.writable) { throw new TypeError("attempted to set read only private field"); } descriptor.value = value; } }
var _require = require('nanoid'),
  nanoid = _require.nanoid;
var emitter = require('events').EventEmitter;
var debug = require('debug')('mockapi');
var j = JSON.stringify;

// stream data emitter
var _response = /*#__PURE__*/new WeakMap();
var _arrData = /*#__PURE__*/new WeakMap();
var _arrDataResolver = /*#__PURE__*/new WeakMap();
var _forEachResolver = /*#__PURE__*/new WeakMap();
var _forEachCallback = /*#__PURE__*/new WeakMap();
var dataEmitter = /*#__PURE__*/function (_emitter) {
  _inherits(dataEmitter, _emitter);
  var _super = _createSuper(dataEmitter);
  function dataEmitter() {
    var _thisSuper, _this;
    _classCallCheck(this, dataEmitter);
    _this = _super.call(this);
    _classPrivateFieldInitSpec(_assertThisInitialized(_this), _response, {
      writable: true,
      value: null
    });
    _classPrivateFieldInitSpec(_assertThisInitialized(_this), _arrData, {
      writable: true,
      value: null
    });
    _classPrivateFieldInitSpec(_assertThisInitialized(_this), _arrDataResolver, {
      writable: true,
      value: null
    });
    _classPrivateFieldInitSpec(_assertThisInitialized(_this), _forEachResolver, {
      writable: true,
      value: null
    });
    _classPrivateFieldInitSpec(_assertThisInitialized(_this), _forEachCallback, {
      writable: true,
      value: null
    });
    _defineProperty(_assertThisInitialized(_this), "pipe", function (res) {
      _classPrivateFieldSet(_assertThisInitialized(_this), _response, res);
      if (res.headers && !res.headers['Content-Type']) {
        res.set('Content-Type', 'application/json');
      }
      res.write('[\n');
      return _assertThisInitialized(_this);
    });
    _defineProperty(_assertThisInitialized(_this), "json", function (res) {
      _classPrivateFieldSet(_assertThisInitialized(_this), _response, res);
      return _this.pipe(res);
    });
    _defineProperty(_assertThisInitialized(_this), "getPipe", function () {
      return _classPrivateFieldGet(_assertThisInitialized(_this), _response);
    });
    _defineProperty(_assertThisInitialized(_this), "toArray", function () {
      _classPrivateFieldSet(_assertThisInitialized(_this), _arrData, new Array());
      return new Promise(function (resolve, reject) {
        _classPrivateFieldSet(_assertThisInitialized(_this), _arrDataResolver, resolve);
      });
    });
    _defineProperty(_assertThisInitialized(_this), "forEach", function (callback) {
      return new Promise(function (resolve, reject) {
        _classPrivateFieldSet(_assertThisInitialized(_this), _forEachResolver, resolve);
        _classPrivateFieldSet(_assertThisInitialized(_this), _forEachCallback, callback);
      });
    });
    _defineProperty(_assertThisInitialized(_this), "emit", function (event, data) {
      if (_classPrivateFieldGet(_assertThisInitialized(_this), _arrData) !== null) {
        if (event === 'data') {
          _classPrivateFieldGet(_assertThisInitialized(_this), _arrData).push(data);
        }
        if (event === 'end') {
          _classPrivateFieldGet(_assertThisInitialized(_this), _arrDataResolver).call(_assertThisInitialized(_this), _classPrivateFieldGet(_assertThisInitialized(_this), _arrData));
        }
      } else if (_classPrivateFieldGet(_assertThisInitialized(_this), _forEachResolver) !== null) {
        if (event === 'data') {
          _classPrivateFieldGet(_assertThisInitialized(_this), _forEachCallback).call(_assertThisInitialized(_this), data);
        }
        if (event === 'end') {
          _classPrivateFieldGet(_assertThisInitialized(_this), _forEachResolver).call(_assertThisInitialized(_this));
        }
      }
      _get((_thisSuper = _assertThisInitialized(_this), _getPrototypeOf(dataEmitter.prototype)), "emit", _thisSuper).call(_thisSuper, event, data);
    });
    return _this;
  }
  _createClass(dataEmitter, [{
    key: "cancel",
    value: function cancel() {
      this.stream.pause();
      this.stream.destroy();
      this.emit('end');
    }
  }, {
    key: "end",
    value: function end() {
      this.stream.pause();
      this.stream.destroy();
      this.emit('end');
    }
  }, {
    key: "pause",
    value: function pause() {
      this.stream.pause();
    }
  }, {
    key: "resume",
    value: function resume() {
      this.stream.resume();
    }
  }]);
  return dataEmitter;
}(emitter);
exports.cohoAPI = function (client, sess) {
  var _module;
  // get stream for range
  var getRange = function getRange(coll) {
    var opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var instream = client.getRange({
      collection: coll,
      optionsJSON: opts
    }, sess);
    var e = new dataEmitter(instream);
    var sep = ' ';
    debug("Instream", instream);
    instream.on('data', function (rec) {
      debug("Get data", rec);
      var pipe = e.getPipe();
      if (pipe) {
        pipe.write(sep);
        pipe.write(j(rec.data));
        if (sep === ' ') {
          sep = ',\n';
        }
      } else {
        e.emit('data', rec.data);
      }
    });
    instream.on('error', function (err) {
      var pipe = e.getPipe();
      if (pipe) {
        pipe.error.error(err);
        pipe.write("{\"error\": \"".concat(err.toString(), "\"}"));
        pipe.status(500).end();
      } else {
        e.emit('error', err);
      }
    });
    instream.on('end', function () {
      var pipe = e.getPipe();
      if (pipe) {
        pipe.write('\n]');
        pipe.end();
      } else {
        e.emit('end');
      }
    });
    return e;
  };

  // add query result to queue topic
  var enqueueFromQuery = function enqueueFromQuery(coll) {
    var query = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var topic = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'NO-TOPIC';
    var opts = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
    return new Promise(function (resolve, reject) {
      opts.filter = query;
      opts.enqueue = topic;
      getRange(coll, opts).on('data', function (result) {
        resolve(result);
      }).on('end', function () {
        // nada
      }).on('error', function (err) {
        reject(err);
      });
    });
  };

  // get one item by key
  var getOne = function getOne(coll, key) {
    var opts = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    return new Promise(function (resolve, reject) {
      if (Array.isArray(key)) {
        opts.idlist = key;
        key = null;
      }
      client.getOne({
        collection: coll,
        key: key,
        optionsJSON: opts
      }, sess, function (err, res) {
        if (err) {
          reject(err);
        } else {
          debug("getOne", res);
          res = res.data;
          resolve(res);
        }
      });
    });
  };

  // find as array query
  var findAsArray = function findAsArray(coll) {
    var opt = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    return new Promise(function (resolve, reject) {
      var arr = new Array();
      var instream = getRange(coll, opt);
      instream.on('data', function (rec) {
        arr.push(rec);
      });
      instream.on('error', function (e) {
        reject(e);
      });
      instream.on('end', function () {
        resolve(arr);
      });
    });
  };

  // update query
  var updateOne = function updateOne(coll, ID, doc) {
    var option = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
    return new Promise(function (resolve, reject) {
      client.updateOne({
        collection: coll,
        id: ID,
        documentJSON: doc,
        optionsJSON: option
      }, sess, function (err, res) {
        if (err) {
          reject(err);
        } else {
          res = res.data;
          resolve(res);
        }
      });
    });
  };
  // replace
  var replaceOne = function replaceOne(coll, ID, doc) {
    var option = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
    return new Promise(function (resolve, reject) {
      client.replaceOne({
        collection: coll,
        id: ID,
        documentJSON: doc,
        optionsJSON: option
      }, sess, function (err, res) {
        if (err) {
          reject(err);
        } else {
          res = res.data;
          resolve(res);
        }
      });
    });
  };
  // update query
  var updateMany = function updateMany(coll, doc) {
    var option = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    return new Promise(function (resolve, reject) {
      debug("UPDATE*", coll, doc, option);
      client.updateMany({
        collection: coll,
        documentJSON: doc,
        optionsJSON: option
      }, sess, function (err, res) {
        if (err) {
          reject(err);
        } else {
          res = res.data;
          resolve(res);
        }
      });
    });
  };
  // replace
  var replaceMany = function replaceMany(coll, doc) {
    var option = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    return new Promise(function (resolve, reject) {
      client.replaceMany({
        collection: coll,
        documentJSON: doc,
        optionsJSON: option
      }, sess, function (err, res) {
        if (err) {
          reject(err);
        } else {
          res = res.data;
          resolve(res);
        }
      });
    });
  };

  // remove one
  var removeOne = function removeOne(coll, ID) {
    var option = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    return new Promise(function (resolve, reject) {
      client.removeOne({
        collection: coll,
        id: ID,
        optionsJSON: option
      }, sess, function (err, res) {
        if (err) {
          reject(err);
        } else {
          res = {
            _id: res.data
          };
          resolve(res);
        }
      });
    });
  };
  // remove many
  var removeMany = function removeMany(coll) {
    var option = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    return new Promise(function (resolve, reject) {
      client.removeMany({
        collection: coll,
        optionsJSON: option
      }, sess, function (err, res) {
        if (err) {
          reject(err);
        } else {
          res = res.data;
          resolve(res);
        }
      });
    });
  };
  // add 
  var insert = function insert(coll, doc) {
    return new Promise(function (resolve, reject) {
      client.save({
        collection: coll,
        payloadJSON: doc
      }, sess, function (err, saveres) {
        if (err) {
          reject(err);
        } else {
          if (saveres.data) {
            resolve(saveres.data);
          } else if (saveres.error) {
            reject(saveres.error);
          } else {
            reject(saveres);
          }
        }
      });
    });
  };

  // enqueue job to _queue collection 
  var enqueue = function enqueue() {
    var topic = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "";
    var payload = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    return new Promise(function (resolve, reject) {
      var jobId = nanoid();
      var _id = nanoid();
      resolve(client.enqueue(topic, {
        topic: topic,
        jobId: jobId,
        _id: _id,
        "payload": payload
      }));
      /*client.save({ collection: `_queue_${topic}`, payloadJSON: { topic, payload, options, _created: new Date().toISOString() } }, sess, (err, saveres) => {
          if (err) {
              reject(err);
          } else {
              if (saveres.data) {
                  resolve(saveres.data);
              } else if (saveres.error) {
                  reject(saveres.error);
              } else {
                  reject(saveres);
              }
           }
       })*/
    });
  };

  // key value set
  var setkv = function setkv(key, value) {
    var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    return new Promise(function (resolve, reject) {
      client.kvset({
        key: key,
        value: value,
        optionsJSON: options || {}
      }, sess, function (err, setres) {
        if (err) {
          reject(err);
        } else {
          resolve(setres.data);
        }
      });
    });
  };
  // key value get
  var getkv = function getkv(key) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    return new Promise(function (resolve, reject) {
      client.kvget({
        key: key,
        optionsJSON: options || {}
      }, sess, function (err, getres) {
        if (err) {
          resolve(null);
        } else {
          if (getres.error) {
            resolve(null);
          } else {
            resolve(getres.data);
          }
        }
      });
    });
  };

  // key value del
  var delkv = function delkv(key) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    return new Promise(function (resolve, reject) {
      client.kvdelete({
        key: key,
        optionsJSON: options || {}
      }, sess, function (err, delres) {
        if (err) {
          reject(err);
        } else {
          debug(delres);
          resolve(delres.data);
        }
      });
    });
  };

  // key value del all
  var delallkv = function delallkv(key) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    return new Promise(function (resolve, reject) {
      client.kvdeleteall({
        key: key,
        optionsJSON: options || {}
      }, sess, function (err, setres) {
        if (err) {
          reject(err);
        } else {
          resolve(setres);
        }
      });
    });
  };

  // key value get all
  var getallkv = function getallkv(key) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var e = new emitter();
    var instream = client.kvgetall({
      key: key,
      optionsJSON: options || {}
    }, sess);
    instream.on('data', function (rec) {
      e.emit('data', rec);
    });
    instream.on('error', function (e) {
      e.emit('error', e);
    });
    instream.on('end', function () {
      e.emit('end');
    });
    return e;
  };

  // key value incr
  var incrkv = function incrkv(key, num) {
    var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    return new Promise(function (resolve, reject) {
      client.kvincr({
        key: key,
        num: num,
        optionsJSON: options || {}
      }, sess, function (err, getres) {
        if (err) {
          reject(err);
        } else {
          if (getres.error) {
            debug("Error", getres);
            resolve(null);
          } else {
            resolve(getres.data);
          }
        }
      });
    });
  };
  // key value decr
  var decrkv = function decrkv(key, num) {
    var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    return new Promise(function (resolve, reject) {
      client.kvdecr({
        key: key,
        num: num,
        optionsJSON: options || {}
      }, sess, function (err, getres) {
        if (err) {
          reject(err);
        } else {
          resolve(parseInt(getres.data));
        }
      });
    });
  };

  // Index api
  // Create indexes
  var createIndex = function createIndex(collection) {
    var index = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
    var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    return new Promise(function (resolve, reject) {
      if (!Array.isArray(index)) {
        index = [index];
      }
      var stream = client.ensureIndex({
        "collection": collection,
        "index": index
      }, sess);
      stream.on('data', function (data) {});
      stream.on('error', function (err) {
        reject(err);
      });
      stream.on('end', function (data) {
        resolve(data);
      });
    });
  };
  // remove indexes
  var removeIndex = function removeIndex(collection) {
    var index = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
    var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    return new Promise(function (resolve, reject) {
      if (!Array.isArray(index)) {
        index = [index];
      }
      client.removeIndex({
        "collection": collection,
        "index": index
      }, sess, function (err, res) {
        if (err) {
          reject(err);
        } else {
          resolve(res);
        }
      });
    });
  };

  // run worker later
  /**
   * 
   * @param {Date} date 
   * @param {Object} payload 
   * @param {String} worker 
   * @returns 
   */
  var runAt = function runAt(date, payload, worker) {
    date = date.toISOString();
    console.log("runAt", {
      date: date,
      payload: payload,
      worker: worker
    });
    return {
      date: date,
      payload: payload,
      worker: worker
    };
  };

  // Codehook client API
  var module = (_module = {
    "find": getRange,
    "findOne": getOne,
    "getRange": getRange,
    "getMany": getRange,
    "getOne": getOne,
    "getArray": findAsArray,
    "updateOne": updateOne,
    "updateMany": updateMany,
    "replaceOne": replaceOne,
    "replaceMany": replaceMany,
    "removeOne": removeOne,
    "removeMany": removeMany,
    "insertOne": insert,
    "insertMany": insert,
    "enqueue": enqueue,
    "get": getkv,
    "getAll": getallkv,
    "set": setkv,
    "incr": incrkv,
    "decr": decrkv,
    "del": delkv,
    "delAll": delallkv
  }, _defineProperty(_module, "enqueue", enqueue), _defineProperty(_module, "enqueueFromQuery", enqueueFromQuery), _defineProperty(_module, "createIndex", createIndex), _defineProperty(_module, "removeIndex", removeIndex), _defineProperty(_module, "runAt", runAt), _module);
  module.collection = function (collname) {
    //console.log("GET COLL", collname)
    return {
      "getOne": function getOne() {
        for (var _len = arguments.length, params = new Array(_len), _key = 0; _key < _len; _key++) {
          params[_key] = arguments[_key];
        }
        return module.getOne.apply(module, [collname].concat(params));
      },
      "getMany": function getMany() {
        for (var _len2 = arguments.length, params = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
          params[_key2] = arguments[_key2];
        }
        return module.getMany.apply(module, [collname].concat(params));
      },
      "find": function find() {
        for (var _len3 = arguments.length, params = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
          params[_key3] = arguments[_key3];
        }
        return module.find.apply(module, [collname].concat(params));
      },
      "insertOne": function insertOne() {
        for (var _len4 = arguments.length, params = new Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
          params[_key4] = arguments[_key4];
        }
        return module.insertOne.apply(module, [collname].concat(params));
      },
      "updateOne": function updateOne() {
        for (var _len5 = arguments.length, params = new Array(_len5), _key5 = 0; _key5 < _len5; _key5++) {
          params[_key5] = arguments[_key5];
        }
        return module.updateOne.apply(module, [collname].concat(params));
      },
      "updateMany": function updateMany() {
        for (var _len6 = arguments.length, params = new Array(_len6), _key6 = 0; _key6 < _len6; _key6++) {
          params[_key6] = arguments[_key6];
        }
        return module.updateMany.apply(module, [collname].concat(params));
      },
      "replaceOne": function replaceOne() {
        for (var _len7 = arguments.length, params = new Array(_len7), _key7 = 0; _key7 < _len7; _key7++) {
          params[_key7] = arguments[_key7];
        }
        return module.replaceOne.apply(module, [collname].concat(params));
      },
      "replaceMany": function replaceMany() {
        for (var _len8 = arguments.length, params = new Array(_len8), _key8 = 0; _key8 < _len8; _key8++) {
          params[_key8] = arguments[_key8];
        }
        return module.replaceMany.apply(module, [collname].concat(params));
      },
      "removeOne": function removeOne() {
        for (var _len9 = arguments.length, params = new Array(_len9), _key9 = 0; _key9 < _len9; _key9++) {
          params[_key9] = arguments[_key9];
        }
        return module.removeOne.apply(module, [collname].concat(params));
      },
      "removeMany": function removeMany() {
        for (var _len10 = arguments.length, params = new Array(_len10), _key10 = 0; _key10 < _len10; _key10++) {
          params[_key10] = arguments[_key10];
        }
        return module.removeMany.apply(module, [collname].concat(params));
      }
    };
  };
  return module;
};