"use strict";

module.exports = function (stream, _ref) {
  var _ref$onClose = _ref.onClose,
    onClose = _ref$onClose === void 0 ? function () {} : _ref$onClose,
    _ref$onEnd = _ref.onEnd,
    onEnd = _ref$onEnd === void 0 ? function () {} : _ref$onEnd,
    _ref$onData = _ref.onData,
    onData = _ref$onData === void 0 ? function () {} : _ref$onData;
  return new Promise(function (resolve, reject) {
    stream.on('close', onClose).on('end', onEnd).on('finish', function () {
      resolve();
    }).on('data', onData).on('error', function (err) {
      reject(err);
    });
  });
};