"use strict";

var _jwksRsa = _interopRequireDefault(require("jwks-rsa"));
var _util = _interopRequireDefault(require("util"));
var _jsonwebtoken = _interopRequireDefault(require("jsonwebtoken"));
var _ref, _ref2, _ref3;
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ _regeneratorRuntime = function _regeneratorRuntime() { return e; }; var t, e = {}, r = Object.prototype, n = r.hasOwnProperty, o = Object.defineProperty || function (t, e, r) { t[e] = r.value; }, i = "function" == typeof Symbol ? Symbol : {}, a = i.iterator || "@@iterator", c = i.asyncIterator || "@@asyncIterator", u = i.toStringTag || "@@toStringTag"; function define(t, e, r) { return Object.defineProperty(t, e, { value: r, enumerable: !0, configurable: !0, writable: !0 }), t[e]; } try { define({}, ""); } catch (t) { define = function define(t, e, r) { return t[e] = r; }; } function wrap(t, e, r, n) { var i = e && e.prototype instanceof Generator ? e : Generator, a = Object.create(i.prototype), c = new Context(n || []); return o(a, "_invoke", { value: makeInvokeMethod(t, r, c) }), a; } function tryCatch(t, e, r) { try { return { type: "normal", arg: t.call(e, r) }; } catch (t) { return { type: "throw", arg: t }; } } e.wrap = wrap; var h = "suspendedStart", l = "suspendedYield", f = "executing", s = "completed", y = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var p = {}; define(p, a, function () { return this; }); var d = Object.getPrototypeOf, v = d && d(d(values([]))); v && v !== r && n.call(v, a) && (p = v); var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p); function defineIteratorMethods(t) { ["next", "throw", "return"].forEach(function (e) { define(t, e, function (t) { return this._invoke(e, t); }); }); } function AsyncIterator(t, e) { function invoke(r, o, i, a) { var c = tryCatch(t[r], t, o); if ("throw" !== c.type) { var u = c.arg, h = u.value; return h && "object" == _typeof(h) && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) { invoke("next", t, i, a); }, function (t) { invoke("throw", t, i, a); }) : e.resolve(h).then(function (t) { u.value = t, i(u); }, function (t) { return invoke("throw", t, i, a); }); } a(c.arg); } var r; o(this, "_invoke", { value: function value(t, n) { function callInvokeWithMethodAndArg() { return new e(function (e, r) { invoke(t, n, e, r); }); } return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(e, r, n) { var o = h; return function (i, a) { if (o === f) throw new Error("Generator is already running"); if (o === s) { if ("throw" === i) throw a; return { value: t, done: !0 }; } for (n.method = i, n.arg = a;;) { var c = n.delegate; if (c) { var u = maybeInvokeDelegate(c, n); if (u) { if (u === y) continue; return u; } } if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) { if (o === h) throw o = s, n.arg; n.dispatchException(n.arg); } else "return" === n.method && n.abrupt("return", n.arg); o = f; var p = tryCatch(e, r, n); if ("normal" === p.type) { if (o = n.done ? s : l, p.arg === y) continue; return { value: p.arg, done: n.done }; } "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg); } }; } function maybeInvokeDelegate(e, r) { var n = r.method, o = e.iterator[n]; if (o === t) return r.delegate = null, "throw" === n && e.iterator["return"] && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y; var i = tryCatch(o, e.iterator, r.arg); if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y; var a = i.arg; return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y); } function pushTryEntry(t) { var e = { tryLoc: t[0] }; 1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e); } function resetTryEntry(t) { var e = t.completion || {}; e.type = "normal", delete e.arg, t.completion = e; } function Context(t) { this.tryEntries = [{ tryLoc: "root" }], t.forEach(pushTryEntry, this), this.reset(!0); } function values(e) { if (e || "" === e) { var r = e[a]; if (r) return r.call(e); if ("function" == typeof e.next) return e; if (!isNaN(e.length)) { var o = -1, i = function next() { for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next; return next.value = t, next.done = !0, next; }; return i.next = i; } } throw new TypeError(_typeof(e) + " is not iterable"); } return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), o(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) { var e = "function" == typeof t && t.constructor; return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name)); }, e.mark = function (t) { return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t; }, e.awrap = function (t) { return { __await: t }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () { return this; }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) { void 0 === i && (i = Promise); var a = new AsyncIterator(wrap(t, r, n, o), i); return e.isGeneratorFunction(r) ? a : a.next().then(function (t) { return t.done ? t.value : a.next(); }); }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () { return this; }), define(g, "toString", function () { return "[object Generator]"; }), e.keys = function (t) { var e = Object(t), r = []; for (var n in e) r.push(n); return r.reverse(), function next() { for (; r.length;) { var t = r.pop(); if (t in e) return next.value = t, next.done = !1, next; } return next.done = !0, next; }; }, e.values = values, Context.prototype = { constructor: Context, reset: function reset(e) { if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t); }, stop: function stop() { this.done = !0; var t = this.tryEntries[0].completion; if ("throw" === t.type) throw t.arg; return this.rval; }, dispatchException: function dispatchException(e) { if (this.done) throw e; var r = this; function handle(n, o) { return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o; } for (var o = this.tryEntries.length - 1; o >= 0; --o) { var i = this.tryEntries[o], a = i.completion; if ("root" === i.tryLoc) return handle("end"); if (i.tryLoc <= this.prev) { var c = n.call(i, "catchLoc"), u = n.call(i, "finallyLoc"); if (c && u) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } else if (c) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); } else { if (!u) throw new Error("try statement without catch or finally"); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } } } }, abrupt: function abrupt(t, e) { for (var r = this.tryEntries.length - 1; r >= 0; --r) { var o = this.tryEntries[r]; if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) { var i = o; break; } } i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null); var a = i ? i.completion : {}; return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a); }, complete: function complete(t, e) { if ("throw" === t.type) throw t.arg; return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y; }, finish: function finish(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y; } }, "catch": function _catch(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.tryLoc === t) { var n = r.completion; if ("throw" === n.type) { var o = n.arg; resetTryEntry(r); } return o; } } throw new Error("illegal catch attempt"); }, delegateYield: function delegateYield(e, r, n) { return this.delegate = { iterator: values(e), resultName: r, nextLoc: n }, "next" === this.method && (this.arg = t), y; } }, e; }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _wrapNativeSuper(Class) { var _cache = typeof Map === "function" ? new Map() : undefined; _wrapNativeSuper = function _wrapNativeSuper(Class) { if (Class === null || !_isNativeFunction(Class)) return Class; if (typeof Class !== "function") { throw new TypeError("Super expression must either be null or a function"); } if (typeof _cache !== "undefined") { if (_cache.has(Class)) return _cache.get(Class); _cache.set(Class, Wrapper); } function Wrapper() { return _construct(Class, arguments, _getPrototypeOf(this).constructor); } Wrapper.prototype = Object.create(Class.prototype, { constructor: { value: Wrapper, enumerable: false, writable: true, configurable: true } }); return _setPrototypeOf(Wrapper, Class); }; return _wrapNativeSuper(Class); }
function _construct(Parent, args, Class) { if (_isNativeReflectConstruct()) { _construct = Reflect.construct.bind(); } else { _construct = function _construct(Parent, args, Class) { var a = [null]; a.push.apply(a, args); var Constructor = Function.bind.apply(Parent, a); var instance = new Constructor(); if (Class) _setPrototypeOf(instance, Class.prototype); return instance; }; } return _construct.apply(null, arguments); }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _isNativeFunction(fn) { return Function.toString.call(fn).indexOf("[native code]") !== -1; }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
var _require = require('fs'),
  writeFileSync = _require.writeFileSync,
  existsSync = _require.existsSync,
  readFileSync = _require.readFileSync;
var tmp = require('tmp');
var lodash = require('lodash');
var mkdirp = require('mkdirp');
var cwd = process.cwd();
var express = require('express');
var crontab = require('node-cron');
var debug = require('debug')('server');
var mockAPI = require('./mockAPI');
var routeMatch = require("node-match-path").match;
var mockDB = require('./mockDB');
var bodyParser = require('body-parser');
var cors = require('cors');
var cookieParser = require('cookie-parser');
var fs = require('fs');
var cronparser = require('cron-parser');
var nocache = require("nocache");
var https = require('https');
var AuthenticationError = /*#__PURE__*/function (_Error) {
  _inherits(AuthenticationError, _Error);
  var _super = _createSuper(AuthenticationError);
  function AuthenticationError(message) {
    var _this;
    _classCallCheck(this, AuthenticationError);
    _this = _super.call(this, message);
    _this.message = message;
    _this.code = 'AUTHERROR';
    return _this;
  }
  return _createClass(AuthenticationError);
}( /*#__PURE__*/_wrapNativeSuper(Error));
var codeTemplate = require('./codetemplate.min').code;
var jwtVerify = _util["default"].promisify(_jsonwebtoken["default"].verify);
var verifyUsingJWKS = function verifyUsingJWKS(_x, _x2) {
  return (_ref = _ref || _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(jwksUri, token) {
    var client, resp, exp;
    return _regeneratorRuntime().wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          client = (0, _jwksRsa["default"])({
            jwksUri: jwksUri
          });
          _context.prev = 1;
          _context.next = 4;
          return jwtVerify(token, function (header, callback) {
            client.getSigningKey(header.kid, function (err, key) {
              if (err) {
                console.log(err);
                return callback(err);
              }
              var signingKey = key.publicKey || key.rsaPublicKey;
              callback(null, signingKey);
            });
          });
        case 4:
          resp = _context.sent;
          exp = null;
          _context.prev = 6;
          // extract expiry unixtime from JWT token
          exp = JSON.parse(Buffer.from(token.split('.')[1], 'base64')).exp;
          _context.next = 13;
          break;
        case 10:
          _context.prev = 10;
          _context.t0 = _context["catch"](6);
          throw new AuthenticationError('Invalid JWT');
        case 13:
          return _context.abrupt("return", {
            payload: resp,
            exp: exp
          });
        case 16:
          _context.prev = 16;
          _context.t1 = _context["catch"](1);
          console.log(_context.t1.message);
          throw new AuthenticationError('Session expired. Sign in again.');
        case 20:
        case "end":
          return _context.stop();
      }
    }, _callee, null, [[1, 16], [6, 10]]);
  }))).apply(this, arguments);
};
var Chain = {
  doneFunc: function doneFunc(output) {
    if (output) console.log(output);
    return this;
  },
  writeFunc: function writeFunc(output) {
    if (output) console.log(output);
    return this;
  },
  setFunc: function setFunc(output, x) {
    if (_typeof(output) === 'object') {
      console.log(output);
    } else {
      var hval = {};
      hval[output] = x;
      console.log({
        "headerdata": _objectSpread({}, hval)
      });
    }
    return this;
  },
  statusFunc: function statusFunc(code, msg) {
    console.log(code, msg);
    return this;
  }
};
exports.startServer = function (_x3, _x4) {
  return (_ref2 = _ref2 || _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(argv, src) {
    var oldlog;
    return _regeneratorRuntime().wrap(function _callee2$(_context2) {
      while (1) switch (_context2.prev = _context2.next) {
        case 0:
          oldlog = console.log;
          console.log = function () {
            Array.prototype.unshift.call(arguments, new Date().toISOString());
            oldlog.apply(this, arguments);
          };
          _startServer(argv, src);
        case 3:
        case "end":
          return _context2.stop();
      }
    }, _callee2);
  }))).apply(this, arguments);
};
var _startServer = function _startServer(_x5, _x6) {
  return (_ref3 = _ref3 || _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee8(argv, src) {
    var _ref4, _serve, _ref6, _ref7;
    var tmpdir, compiled, runTimeCode, rt, hook, queueFunc, client, app, port, datastore, serve, options, server;
    return _regeneratorRuntime().wrap(function _callee8$(_context8) {
      while (1) switch (_context8.prev = _context8.next) {
        case 0:
          serve = function _serve2(_x9, _x10, _x11) {
            return (_serve = _serve || _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee5(req, res, next) {
              var _this2 = this;
              var resWrapper, routematchdata, hookroute, thekey, subPath, routematch, ctx, theFunc, allDone, globalError;
              return _regeneratorRuntime().wrap(function _callee5$(_context5) {
                while (1) switch (_context5.prev = _context5.next) {
                  case 0:
                    resWrapper = {
                      end: function end(param) {
                        if (param) {
                          if (_typeof(param) === 'object') {
                            param = JSON.stringify(param);
                          }
                          res.send(param);
                        } else {
                          res.end();
                        }
                        return _this2;
                      },
                      send: function send(param) {
                        if (param) {
                          if (_typeof(param) === 'object') {
                            param = JSON.stringify(param);
                          }
                          res.send(param);
                        } else {
                          res.end();
                        }
                        return _this2;
                      },
                      json: function json(param) {
                        res.json(param);
                        return _this2;
                      },
                      set: function set(param) {
                        res.set(param);
                        return _this2;
                      },
                      headers: function headers(param) {
                        res.setHeaders(param);
                        return _this2;
                      },
                      write: function write(param) {
                        res.write(param);
                        return _this2;
                      },
                      status: function status(param) {
                        res.status(param);
                        return _this2;
                      }
                    };
                    if (!hook.routehooks) {
                      _context5.next = 55;
                      break;
                    }
                    routematchdata = null;
                    hookroute = null;
                    thekey = null;
                    subPath = '/' + req.path.split('/').splice(2).join('/');
                    routematch = lodash.find(hook.routehooks, function (ahook, key) {
                      debug("Matching", key, subPath);
                      try {
                        thekey = key;
                        var method = key.substring(0, key.indexOf(" /"));
                        method = lodash.trim(method);
                        hookroute = key.substr(key.indexOf("/"));
                        hookroute = lodash.trim(hookroute);
                        routematchdata = routeMatch(hookroute, subPath);
                        //routematchdata = route.match(subPath);

                        debug("Hit", subPath, hookroute, routematchdata);
                        if (routematchdata.matches && (method === req.method || method === '*')) return true;
                      } catch (ex) {
                        debug("Not a route match", subPath, ex);
                        return false;
                      }
                    });
                    if (!routematch) {
                      _context5.next = 51;
                      break;
                    }
                    debug("Route match", routematch);
                    ctx = {
                      "hostname": req.hostname,
                      "headers": req.headers,
                      "query": req.query,
                      "path": req.path,
                      "apiPath": subPath,
                      "originalUrl": req.originalUrl,
                      "params": routematchdata.params,
                      "body": req.body,
                      "method": req.method,
                      "datastore": req.params.dbname
                    };
                    theFunc = hook.routehooks[thekey];
                    _context5.prev = 11;
                    if (!theFunc) {
                      _context5.next = 41;
                      break;
                    }
                    // run global middleware first						
                    allDone = false;
                    globalError = null;
                    if (!(hook.globalhooks && hook.globalhooks.length > 0)) {
                      _context5.next = 26;
                      break;
                    }
                    _context5.prev = 16;
                    _context5.next = 19;
                    return new Promise(function (resolve) {
                      var done = false;
                      var ghooks = hook.globalhooks.filter(function (x) {
                        if (x.path && routeMatch(x.path, subPath).matches) {
                          return true;
                        } else if (!x.path) {
                          return true;
                        }
                        return false;
                      }).map(function (x) {
                        if (x.path) {
                          return x.func;
                        } else {
                          return x;
                        }
                      });
                      debug('Exec global hook', ghooks);
                      rt.execAll(ghooks, ctx, res, function (nextparam) {
                        done = true;
                        if (nextparam !== undefined) {
                          done = false;
                          globalError = nextparam;
                        }
                        ;
                        resolve(done);
                      });
                    });
                  case 19:
                    allDone = _context5.sent;
                    _context5.next = 26;
                    break;
                  case 22:
                    _context5.prev = 22;
                    _context5.t0 = _context5["catch"](16);
                    console.log("Global hooks error", _context5.t0);
                    res.status(500).end(_context5.t0.message);
                  case 26:
                    if (!(hook.globalhooks && hook.globalhooks.length > 0 && allDone === false)) {
                      _context5.next = 32;
                      break;
                    }
                    debug("Next not called from globalhooks", globalError);
                    if (!(globalError !== null)) {
                      _context5.next = 30;
                      break;
                    }
                    return _context5.abrupt("return", res.status(500).end(globalError));
                  case 30:
                    _context5.next = 39;
                    break;
                  case 32:
                    if (!Array.isArray(theFunc)) {
                      _context5.next = 37;
                      break;
                    }
                    _context5.next = 35;
                    return rt.execAll(theFunc, ctx, res, next);
                  case 35:
                    _context5.next = 39;
                    break;
                  case 37:
                    _context5.next = 39;
                    return theFunc(ctx, res, next);
                  case 39:
                    _context5.next = 42;
                    break;
                  case 41:
                    console.log("Missing routehook function for", thekey);
                  case 42:
                    _context5.next = 49;
                    break;
                  case 44:
                    _context5.prev = 44;
                    _context5.t1 = _context5["catch"](11);
                    debug(_context5.t1);
                    console.log(_context5.t1.message);
                    res.status(500).end(_context5.t1.message);
                  case 49:
                    _context5.next = 53;
                    break;
                  case 51:
                    debug('No routes');
                    res.status(404).end('No maching routes in code');
                  case 53:
                    _context5.next = 57;
                    break;
                  case 55:
                    debug('No routehooks');
                    res.status(404).end('No routehooks in code');
                  case 57:
                  case "end":
                    return _context5.stop();
                }
              }, _callee5, null, [[11, 44], [16, 22]]);
            }))).apply(this, arguments);
          };
          tmpdir = '.localserver';
          _context8.next = 4;
          return mkdirp(tmpdir);
        case 4:
          compiled = lodash.template(codeTemplate);
          runTimeCode = compiled({
            'projectID': 'localhost',
            'datastoreID': 'database',
            'sessionID': 'session',
            'serverPort': argv.port,
            'serverIP': 'localhost',
            'op': 'op',
            'code': src,
            'context': 'input',
            'recurseLevel': 'recurseLevel',
            '_timeout': 60000
          });
          writeFileSync("".concat(cwd, "/").concat(tmpdir, "/runtime.cjs"), runTimeCode);
          rt = require("".concat(cwd, "/").concat(tmpdir, "/runtime.cjs"));
          hook = rt.code["default"];
          if (hook.globalhooks) {
            //hook.globalhooks = lodash.flatten(hook.globalhooks);
          }
          if (argv.debug) console.log(hook);
          rt.setEnv(process.env);
          // setup mock DB
          queueFunc = function queueFunc(_x7, _x8) {
            return (_ref4 = _ref4 || _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee3(queueItem, cb) {
              var topic, theFunc, ctx;
              return _regeneratorRuntime().wrap(function _callee3$(_context3) {
                while (1) switch (_context3.prev = _context3.next) {
                  case 0:
                    debug("Got queue item", queueItem);
                    _context3.prev = 1;
                    topic = queueItem.topic;
                    theFunc = hook.queuehooks[topic];
                    ctx = {
                      body: queueItem
                    };
                    if (!theFunc) {
                      _context3.next = 15;
                      break;
                    }
                    if (!Array.isArray(theFunc)) {
                      _context3.next = 11;
                      break;
                    }
                    _context3.next = 9;
                    return rt.execAll(theFunc, ctx, {
                      "end": cb
                    });
                  case 9:
                    _context3.next = 13;
                    break;
                  case 11:
                    _context3.next = 13;
                    return theFunc(ctx, {
                      "end": cb
                    });
                  case 13:
                    _context3.next = 16;
                    break;
                  case 15:
                    console.log("Missing queuehook for topic:", topic);
                  case 16:
                    _context3.next = 21;
                    break;
                  case 18:
                    _context3.prev = 18;
                    _context3.t0 = _context3["catch"](1);
                    console.log(_context3.t0.message);
                  case 21:
                  case "end":
                    return _context3.stop();
                }
              }, _callee3, null, [[1, 18]]);
            }))).apply(this, arguments);
          };
          client = mockDB.DB("".concat(cwd, "/").concat(tmpdir, "/localdb.json"), queueFunc); // setup express
          app = express();
          app.use(bodyParser.json({
            limit: '1250mb'
          }));
          app.use(bodyParser.urlencoded({
            limit: '1250mb',
            extended: true
          }));

          // CORS settings
          app.use(cors());

          // Cache nope
          app.use(nocache());

          // Cookies
          app.use(cookieParser());
          port = argv.port;
          datastore = function datastore() {};
          datastore.open = function (params) {
            return new Promise(function (resolve, reject) {
              debug("Open DB", params);
              var theapi = mockAPI.cohoAPI(client);
              resolve(theapi);
            });
          };
          rt.setDataStore(datastore);

          /*
          	Mock data import
          */
          app.post('/:dbname/_A_D_M_restore/:collname', function (req, res) {
            var project = req.hostname || 'localhost';
            var dbname = req.params.dbname;
            var coll = req.params.collname;
            debug(project, dbname, coll);
            var body = req.body;
            var sess = {};
            debug('Body', body);
            res.setHeader('Content-Type', 'application/json');
            client.save({
              collection: coll,
              payloadJSON: body
            }, sess, function (err, saveres) {
              debug(err, saveres);
              if (err) {
                res.send({
                  code: err.code
                });
              } else {
                if (saveres.error) {
                  var status = parseInt(saveres.status) || 400;
                  res.status(status).send(saveres.error);
                } else {
                  res.status(201).send(saveres.data);
                }
              }
            });
          });

          /*
            Mock jobhooks
          */
          if (hook && hook.jobhooks) {
            lodash.each(hook.jobhooks, function (ajob, cronexpr) {
              debug("Start job", cronexpr);
              try {
                // verify cron expression
                cronparser.parseExpression(cronexpr);
                var newtimer = crontab.schedule(cronexpr, /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee4() {
                  var theFunc, theContext;
                  return _regeneratorRuntime().wrap(function _callee4$(_context4) {
                    while (1) switch (_context4.prev = _context4.next) {
                      case 0:
                        theFunc = hook.jobhooks[cronexpr];
                        theContext = {
                          json: Chain.doneFunc,
                          end: Chain.doneFunc,
                          write: Chain.writeFunc,
                          set: Chain.setFunc,
                          headers: Chain.setFunc,
                          status: Chain.statusFunc
                        };
                        debug('tick', cronexpr, theFunc);
                        _context4.prev = 3;
                        if (!Array.isArray(theFunc)) {
                          _context4.next = 9;
                          break;
                        }
                        _context4.next = 7;
                        return rt.execAll(theFunc, {}, theContext);
                      case 7:
                        _context4.next = 11;
                        break;
                      case 9:
                        _context4.next = 11;
                        return theFunc({}, theContext);
                      case 11:
                        _context4.next = 16;
                        break;
                      case 13:
                        _context4.prev = 13;
                        _context4.t0 = _context4["catch"](3);
                        console.log("Cron err", _context4.t0.message);
                      case 16:
                      case "end":
                        return _context4.stop();
                    }
                  }, _callee4, null, [[3, 13]]);
                })));
              } catch (ex) {
                console.error("Something is fishy with the cron expression", "'".concat(cronexpr, "'"));
                if (argv.debug) console.error(ex.message);
                debug(ex);
                process.exit(1);
              }
            });
          }

          /*
            Mock routehooks
          */

          app.use(function (_x12, _x13, _x14) {
            return (_ref6 = _ref6 || _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee6(req, res, next) {
              var result, routematchdata, hookroute, thekey, subPath, routematch, ctx, theFunc;
              return _regeneratorRuntime().wrap(function _callee6$(_context6) {
                while (1) switch (_context6.prev = _context6.next) {
                  case 0:
                    if (!argv.auth) {
                      _context6.next = 59;
                      break;
                    }
                    if (!argv.jwks) {
                      _context6.next = 15;
                      break;
                    }
                    _context6.prev = 2;
                    if (req.headers.authorization) {
                      _context6.next = 5;
                      break;
                    }
                    throw "Missing authorization Bearer header";
                  case 5:
                    _context6.next = 7;
                    return verifyUsingJWKS(argv.jwks, req.headers.authorization.replace('Bearer ', ''));
                  case 7:
                    result = _context6.sent;
                    return _context6.abrupt("return", next());
                  case 11:
                    _context6.prev = 11;
                    _context6.t0 = _context6["catch"](2);
                    console.log(_context6.t0.message);
                    return _context6.abrupt("return", res.status(401).json({
                      error: 'Unable to verify token (JWKS)'
                    }));
                  case 15:
                    if (!(argv.apikey === req.headers['x-apikey'])) {
                      _context6.next = 19;
                      break;
                    }
                    next();
                    _context6.next = 57;
                    break;
                  case 19:
                    if (!hook.authhooks) {
                      _context6.next = 55;
                      break;
                    }
                    routematchdata = null;
                    hookroute = null;
                    thekey = null;
                    subPath = '/' + req.path.split('/').splice(2).join('/');
                    routematch = lodash.find(hook.authhooks, function (ahook, key) {
                      debug("Matching auth hook", key, subPath);
                      try {
                        thekey = key;
                        var method = key.substr(0, key.indexOf(" /"));
                        method = lodash.trim(method);
                        hookroute = key.substr(key.indexOf("/"));
                        hookroute = lodash.trim(hookroute);
                        routematchdata = routeMatch(hookroute, subPath);
                        //routematchdata = route.match(subPath);

                        debug("Hit auth hook", subPath, hookroute, routematchdata);
                        if (routematchdata.matches) return true;
                      } catch (ex) {
                        debug("Not a auth route match", subPath, ex);
                        return false;
                      }
                    });
                    if (!routematch) {
                      _context6.next = 51;
                      break;
                    }
                    debug("Exec aut func", routematch);
                    ctx = {
                      "hostname": req.hostname,
                      "headers": req.headers,
                      "query": req.query,
                      "path": req.path,
                      "apiPath": subPath,
                      "originalUrl": req.originalUrl,
                      "params": routematchdata.params,
                      "body": req.body,
                      "method": req.method,
                      "datastore": req.params.dbname
                    };
                    theFunc = hook.authhooks[thekey];
                    debug("Call func", theFunc);
                    _context6.prev = 30;
                    if (!theFunc) {
                      _context6.next = 41;
                      break;
                    }
                    if (!Array.isArray(theFunc)) {
                      _context6.next = 37;
                      break;
                    }
                    _context6.next = 35;
                    return theFunc[0](ctx, res, next);
                  case 35:
                    _context6.next = 39;
                    break;
                  case 37:
                    _context6.next = 39;
                    return theFunc(ctx, res, next);
                  case 39:
                    _context6.next = 43;
                    break;
                  case 41:
                    console.log("Missing authhook function for", thekey);
                    res.end('Missing auth hook function for ');
                  case 43:
                    _context6.next = 49;
                    break;
                  case 45:
                    _context6.prev = 45;
                    _context6.t1 = _context6["catch"](30);
                    debug(_context6.t1);
                    console.error(_context6.t1.message);
                    //res.status(500).end(ex.message);
                  case 49:
                    _context6.next = 53;
                    break;
                  case 51:
                    debug('No routes');
                    res.status(403).end('Not allowed');
                  case 53:
                    _context6.next = 57;
                    break;
                  case 55:
                    debug('No auth hooks');
                    res.status(403).end("Wrong x-apikey or Bearer header: ".concat(req.headers['x-apikey']));
                  case 57:
                    _context6.next = 60;
                    break;
                  case 59:
                    next();
                  case 60:
                  case "end":
                    return _context6.stop();
                }
              }, _callee6, null, [[2, 11], [30, 45]]);
            }))).apply(this, arguments);
          });
          app.all('/:dbname*', function (_x15, _x16, _x17) {
            return (_ref7 = _ref7 || _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee7(req, res, next) {
              return _regeneratorRuntime().wrap(function _callee7$(_context7) {
                while (1) switch (_context7.prev = _context7.next) {
                  case 0:
                    //console.log("REQ", req)
                    // if (res.push) req.isHttp2 = true;
                    //console.log('AlpnProtocol: ' , req.connection.alpnProtocol)
                    //console.log('Request HTTP Version: ', req.httpVersion)
                    serve(req, res, next);
                  case 1:
                  case "end":
                    return _context7.stop();
                }
              }, _callee7);
            }))).apply(this, arguments);
          });
          app.all('*', function (req, res) {
            res.status(500).end("Missing a final route match. ".concat(req.path));
          });
          if (argv.https) {
            options = {
              key: fs.readFileSync(__dirname + '/certs/server.key'),
              cert: fs.readFileSync(__dirname + '/certs/server.crt'),
              allowHTTP1: true,
              plain: true,
              ssl: false
            };
            server = https.createServer(options, app);
            server.listen(port, function () {
              console.log("Codehooks listening on (secure) https://localhost:".concat(port));
            }).on('error', function (msg) {
              return console.error("HTTPS error in startup server:", msg);
            });
          } else {
            app.listen(port, 'localhost', function (error) {
              if (error) {
                console.error(error);
                return process.exit(1);
              } else {
                console.log("Codehooks listening on (http/1) http://localhost:".concat(port));
              }
            });
          }
        case 30:
        case "end":
          return _context8.stop();
      }
    }, _callee8);
  }))).apply(this, arguments);
};